#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

void checkBatteryStatus()
{
    static char prevStatus[12] = ""; // Menyimpan status sebelumnya
    char status[12];

    // Buka file /sys/class/power_supply/battery/status untuk membaca status baterai
    FILE *fp = fopen("/sys/class/power_supply/battery/status", "r");
    if (fp == NULL)
    {
        printf("Error: Unable to open file\n");
        exit(1);
    }

    // Baca status baterai dari file
    fscanf(fp, "%s", status);
    fclose(fp);

    // Periksa status baterai dan berikan pesan echo sesuai dengan statusnya
    if (strcmp(status, "Charging") == 0 && strcmp(prevStatus, "Charging") != 0)
    {
    if (access("/data/adb/modules/adt", F_OK) == 0)
    {
        system("find /sys -name mode | grep 'thermal_zone' | while IFS= read -r thermal_zone_status; do if [ \"$(cat \"$thermal_zone_status\")\" = 'disabled' ]; then echo 'enabled' > \"$thermal_zone_status\"; fi; done");
        sleep(1);
        system("find /sys -name enabled | grep 'msm_thermal' | while IFS= read -r msm_thermal_status; do if [ \"$(cat \"$msm_thermal_status\")\" = 'N' ]; then echo 'Y' > \"$msm_thermal_status\"; fi; if [ \"$(cat \"$msm_thermal_status\")\" = '0' ]; then echo '1' > \"$msm_thermal_status\"; fi; done");
        system("start logd");
        sleep(1);
        system("for thermal in $(resetprop | awk -F '[][]' '/thermal/ {print $2}'); do if [ \"$(resetprop \"$thermal\")\" = 'stopped' ]; then sleep 1; start \"$(echo \"$thermal\" | sed 's/init.svc.//')\"; fi; sleep 3; if [ \"$(resetprop \"$thermal\")\" = 'stopped' ]; then resetprop -n \"$thermal\" running; fi; done");
        sleep(1);
        if (system("resetprop sys.thermal.enable | grep -q 'false'") == 0)
        {
            system("resetprop -n sys.thermal.enable true");
        }
        sleep(1);
        system("find /sys -name temp | grep 'thermal_zone' | while IFS= read -r thermal_zone_temp; do if [ ! -r \"$thermal_zone_temp\" ]; then chmod a+r \"$thermal_zone_temp\"; fi; done");
    }
    else
    {
        system("reboot");
    }
        printf("Battery is currently charging.\n");
        strcpy(prevStatus, "Charging"); // Update status sebelumnya
    }
    else if (strcmp(status, "Discharging") == 0 && strcmp(prevStatus, "Discharging") != 0)
    {
    if (access("/data/adb/modules/adt", F_OK) == 0)
    {
        system("find /sys -name mode | grep 'thermal_zone' | while IFS= read -r thermal_zone_status; do if [ \"$(cat \"$thermal_zone_status\")\" = 'enabled' ]; then echo 'disabled' > \"$thermal_zone_status\"; fi; done");
        sleep(1);
        system("find /sys -name enabled | grep 'msm_thermal' | while IFS= read -r msm_thermal_status; do if [ \"$(cat \"$msm_thermal_status\")\" = 'Y' ]; then echo 'N' > \"$msm_thermal_status\"; fi; if [ \"$(cat \"$msm_thermal_status\")\" = '1' ]; then echo '0' > \"$msm_thermal_status\"; fi; done");
        system("stop logd");
        sleep(1);
        system("for thermal in $(resetprop | awk -F '[][]' '/thermal/ {print $2}'); do if [ \"$(resetprop \"$thermal\")\" = 'running' ] || [ \"$(resetprop \"$thermal\")\" = 'restarting' ]; then sleep 1; stop \"$(echo \"$thermal\" | sed 's/init.svc.//')\"; fi; sleep 3; if [ \"$(resetprop \"$thermal\")\" = 'running' ] || [ \"$(resetprop \"$thermal\")\" = 'restarting' ]; then resetprop -n \"$thermal\" stopped; fi; done");
        sleep(1);
        if (system("resetprop sys.thermal.enable | grep -q 'true'") == 0)
        {
            system("resetprop -n sys.thermal.enable false");
        }
        sleep(1);
        system("find /sys -name temp | grep 'thermal_zone' | while IFS= read -r thermal_zone_temp; do if [ -r \"$thermal_zone_temp\" ]; then chmod a-r \"$thermal_zone_temp\"; fi; done");
    }
    else
    {
        system("reboot");
    }
        printf("Battery is currently discharging.\n");
        strcpy(prevStatus, "Discharging"); // Update status sebelumnya
    }
}

int main()
{
    while (1)
    {
        checkBatteryStatus(); // Panggil fungsi untuk memeriksa status baterai

        // Tunggu selama 2 detik sebelum memeriksa kembali
        sleep(2);
    }

    return 0;
}
